/*
Copyright 2021 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

@import "./views/settings/ProfileSettings.pcss";
@import "./views/dialogs/UserPreviewWidget.pcss";
@import "./views/dialogs/CelebrationDialog.pcss";
@import "./views/dialogs/ReleaseNotes.pcss";
@import "./views/dialogs/SpotlightDialog.pcss";
@import "./views/dialogs/ShareDialog.pcss";
@import "./views/dialogs/InviteDialog.pcss";
@import "./views/EncryptionIcon.pcss";
@import "./views/dialogs/A11yDeclaration.pcss";
@import "./cs/ContentScanner.pcss";
@import "./managers/Maintenance.pcss";
@import "./components/components.pcss";

/* Temporary theme overrides */

/* body {
    --cpd-color-bg-action-primary-rest: var(--accent);
    --cpd-color-border-interactive-secondary: var(--accent);
    --cpd-color-icon-accent-tertiary: var(--accent);
    --cpd-color-bg-accent-rest: var(--accent);
} */

/* Theme overrides end */

$h3-font-size: 1.17em;

.mx_ThemeSelector_light,
.mx_ThemeSelector_dark {
    display: none !important;
}

.mx_UserMenu_contextMenu_name {
    width: 100% !important;
}

.mx_UserMenu_contextMenu_themeButton {
    display: none !important;
}

.mx_RoomView_timeline {
    .mx_JumpToBottomButton_scrollDown {
        background: #91a1c0;
        border: none;

        &::before {
            background: #fff;
        }
    }
}

.mx_UserMenu_headerButtons::before {
    mask-image: url("$(res)/img/bwi/burger_menu.svg") !important;
}

body .mx_E2EIcon_verified::after {
    background-color: #01ab7b;
}

.mx_RoomSublist_badgeContainer,
.mx_RoomTile_badgeContainer {
    .mx_NotificationBadge.mx_NotificationBadge_visible {
        background-color: rgb(78, 90, 111);
        font-weight: 700;
    }
}

/*
    feature/MESSENGER-1487_invite_with_role
*/
.mx_InviteDialog_powerLevel {
    display: flex;
    flex-direction: row;
    margin-right: 45px;
    align-items: center;
    .mx_InviteDialog_goButton {
        min-width: 48px;
        margin-left: 10px;
        height: 25px;
        line-height: $font-25px;
    }

    .mx_InviteDialog_buttonAndSpinner {
        align-self: center;
        display: flex;
        flex-direction: row;
        .mx_Spinner {
            /*  Width and height are required to trick the layout engine. */
            width: 20px;
            height: 20px;
            margin-left: 5px;
            display: inline-block;
            vertical-align: middle;
        }
    }
}
/*
    MESSENGER-1478 Room Quick Invite as in _RightPanel.pcss
*/
.mx_RoomHeader_roomInviteButton::before {
    mask-image: url("$(res)/img/element-icons/room/invite.svg");
    mask-position: center;
}

/*
    MESSENGER-2074 ReceiptsDialog
*/

.mx_EventTile_readAvatars {
    cursor: pointer;
}

.mx_ReceiptsDialog_tile {
    display: flex;
    align-items: center;
    justify-content: space-between;
}

.mx_ReceiptsDialog_userSections {
    margin-top: 4px;
    margin-bottom: 4px;
    overflow-y: auto;
    padding: 0 45px 4px 0;
    height: calc(100% - 75px);
}

.mx_ReceiptsDialog_userList {
    padding: 25px 10px 0px 10px;
}

.mx_ReceiptsDialog_addressBar {
    display: flex;
    flex-direction: row;
    /*  Right margin for the design. We could apply this to the whole dialog, but then the scrollbar */
    /*  for the user section gets weird. */
    margin: 8px 45px 0 0;

    .mx_ReceiptsDialog_editor {
        flex: 1;
        width: 100%; /*  Needed to make the Field inside grow */
        background-color: $header-panel-bg-color;
        border-radius: 4px;
        min-height: 25px;
        padding-left: 8px;
        overflow: hidden;
        /* overflow-y: auto; */
        display: flex;
        flex-wrap: wrap;

        .mx_ReceiptsDialog_userTile {
            margin: 6px 6px 10px 10px;
            display: inline-block;
            min-width: max-content; /*  prevent manipulation by flexbox */
        }

        /*  Mostly copied from AddressPickerDialog; overrides bunch of our default text input styles */
        > input[type="text"] {
            margin: 6px 0 !important;
            height: 24px;
            line-height: $font-24px;
            font-size: $font-14px;
            padding-left: 12px;
            border: 0 !important;
            outline: 0 !important;
            resize: none;
            box-sizing: border-box;
            min-width: 40%;
            flex: 1 !important;
            color: $primary-content !important;
        }
    }
}

/*  Many of these styles are stolen from mx_UserPill, but adjusted for the invite dialog. */
.mx_ReceiptsDialog_userTile {
    margin-right: 8px;

    .mx_ReceiptsDialog_userTile_pill {
        background-color: $username-variant1-color;
        border-radius: 12px;
        display: inline-block;
        height: 24px;
        line-height: $font-24px;
        padding-left: 8px;
        padding-right: 8px;
        color: #ffffff; /*  this is fine without a var because it's for both themes */

        .mx_ReceiptsDialog_userTile_avatar {
            border-radius: 20px;
            position: relative;
            left: -5px;
            top: 2px;
        }

        img.mx_ReceiptsDialog_userTile_avatar {
            vertical-align: top;
        }

        .mx_ReceiptsDialog_userTile_name {
            vertical-align: top;
        }

        .mx_ReceiptsDialog_userTile_threepidAvatar {
            background-color: #ffffff; /*  this is fine without a var because it's for both themes */
        }
    }

    .mx_ReceiptsDialog_userTile_remove {
        display: inline-block;
        margin-left: 4px;
    }
}

.mx_ReceiptsDialog {
    /*  Prevent the dialog from jumping around randomly when elements change. */
    height: 600px;
    padding-left: 20px; /*  the design wants some padding on the left */
    display: flex;
    flex-direction: column;

    .mx_ReceiptsDialog_content {
        overflow: hidden;
        /* overflow-y: auto; */
    }
}

.mx_ReceiptsDialog_helpText {
    margin: 0;
}

.mx_ReceiptsDialog_helpText .mx_AccessibleButton_kind_link {
    padding: 0;
}

.mx_ReceiptsDialog_noResultText {
    text-align: center;
    display: block;
    line-height: $font-30px;
    font-size: $h3-font-size;
    font-weight: bold;
}

/*  MESSENGER-1997 */
.mx_SettingsTab_securityHint {
    font-weight: 600;
    font-size: $font-14px;
    color: $primary-content;
}

/*  MESSENGER-1988 */
.mx_EventTile,
.mx_EventTile .mx_EventTile_content .markdown-body {
    a:hover,
    a:link,
    a:visited {
        color: $links;
        text-decoration: none;

        &:hover {
            text-decoration: underline;
        }
    }
}

.mx_EventTile:hover,
.mx_EventTile:hover .mx_EventTile_content .markdown-body {
    a:hover,
    a:link,
    a:visited {
        color: $links;
    }
}

/*  MESSENGER-1458 */
.mx_SetupEncryptionDialog {
    .mx_Dialog_title {
        display: flex;
        align-items: center;
    }

    .mx_CompleteSecurity_headerIcon {
        display: block;
    }
}

.mx_AuthBody_bwiButtonContainer {
    display: flex;
    justify-content: space-between;

    .mx_AccessibleButton {
        border: none;
        font-size: $font-14px;
        font-weight: 600;
        color: $authpage-lang-color;
        width: auto;
        margin-right: 10px;
    }

    /*  MESSENGER-2524 */
    .mx_AuthBody_bwiRegister {
        margin-left: auto;
    }
}

.mx_AuthBody_bwiRegister:hover {
    text-decoration: underline;
}

.mx_AuthBody_bwiRegister_content {
    font-size: $font-16px;
    margin-right: 48px;
}

/*  MESSENGER-2464 */
.mx_AccessSecretStorageDialog_keyStatus {
    color: $alert;
    font-size: $font-16px;
    font-weight: var(--font-semi-bold);
}

/*  MESSENGER-2561 */
.mx_CompleteSecurityBody p {
    padding: 25px 20px 20px 10px;
    text-align: center;
}

.mx_HelpUserSettingsTab_versions {
    margin-top: 30px;
}

/*  MESSENGER-2640 */
.mx_Bwi_NotAllowedCursor {
    cursor: not-allowed;
    input {
        cursor: not-allowed;
    }
}

.bwi_UserMenu_spacesDisabled {
    margin-right: 8px;
}

.bwi_VerificationRequest_cancel {
    margin-top: 10px;
}

/*  MESSENGER-3622: Fixes image not overflowing container boundaries. */
.mx_UserOnboardingHeader .mx_UserOnboardingHeader_image {
    height: 100%;
}

/*  MESSENGER-2617 */
.mx_LegacyRoomHeader_wrapper {
    border-bottom: 1px solid $quinary-content;
}

/*  MESSENGER-3935 */
.bwi_UserSettingsDialog_legalIcon::before {
    mask-image: url("$(res)/img/element-icons/room/files.svg");
}

/*  MESSENGER-4242 Reverse layout order */
#mx_RightPanel .mx_MemberList .mx_MemberList_invite {
    flex: 1;
    margin-bottom: var(--cpd-space-2x);
}

/*  MESSENGER-4574 Huddle. Video Call button */
.mx_RoomHeader_videoCallButton {
    color: $accent-fg-color;
}

/*  MESSENGER-5277 user info id secondary color */
.mx_UserInfo.mx_BaseCard .mx_UserInfo_profile .mx_UserInfo_profile_mxid.--bwi {
    color: var(--cpd-color-text-secondary);
}

/*  MESSENGER-5320 */
.mx_Login_alternative {
    font-size: $font-16px;
    font-weight: var(--cpd-font-weight-semibold);
    text-align: center;
    margin-bottom: $spacing-24;
}

.mx_RoomSummaryCard_roomName.--bwi,
.mx_RoomSummaryCard_alias.--bwi {
    display: block;
}

.mx_AccessibleButton.bwi_choose_different_secure_phrase_text {
    text-align: left;
}

/* MESSENGER-5397 Federation: Profile settings global avatar information */
.bwi_ProfileSettings_avatarFederationInfo {
    display: flex;
    align-items: center;
    margin-top: 0px;
    padding: 10px 10px 0 10px;
}
.bwi_ProfileSettings_avatarFederationInfo::before {
    content: "";
    display: inline-block;
    height: 24px;
    width: 24px;
    mask-image: url("$(res)/img/element-icons/room/room-summary.svg");
    mask-position: center;
    mask-repeat: no-repeat;
    mask-size: contain;
    background-color: var(--cpd-color-icon-tertiary);
    margin-right: var(--cpd-space-2x);
}

.mx_LoginWithQR.--bwi {
    padding-right: var(--cpd-space-8x);
}
